ProductOfInertia 属性 (ActiveX)
获取固体或区域的惯性乘积。 支持的平台:仅限 Windows 属性值只读:是的 类型:变体(双打的三元素阵列) 在当前坐标系上计算的 X、Y 和 Z 坐标。 言论惯性的乘积以 X、Y 和 Z 坐标的形式返回,定义为变体。它是根据当前坐标系计算的。 例子VBA: Sub Example_ProductOfInertia() ' This example creates a box in model space. ' It then returns the ProductOfInertia for that box. Dim boxObj As Acad3DSolid Dim length As Double, width As Double, height As Double Dim center(0 To 2) As Double ' Define the box center(0) = 5#: center(1) = 5#: center(2) = 0 length = 5#: width = 7: height = 10# ' Create the box (3DSolid) object in model space Set boxObj = ThisDrawing.ModelSpace.AddBox(center, length, width, height) ' Change the viewing direction of the viewport to better see the box Dim NewDirection(0 To 2) As Double NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1 ThisDrawing.ActiveViewport.direction = NewDirection ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport ZoomAll ' Return the ProductOfInertia for the box Dim ProductOfInertia As Variant ProductOfInertia = boxObj.ProductOfInertia MsgBox "The ProductOfInertia for the box is " & ProductOfInertia(0) & ", " & ProductOfInertia(1) & ", " & ProductOfInertia(2), , "ProductOfInertia Example" End Sub 可视化 LISP: (vl-load-com) (defun c:Example_ProductOfInertia() ;; This example creates a box in model space. ;; It then returns the ProductOfInertia for that box. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) ;; Define the box (setq center (vlax-3d-point 5 5 0) boxLength 5 boxWidth 7 boxHeight 10) ;; Create the box (3DSolid) object in model space (setq modelSpace (vla-get-ModelSpace doc)) (setq boxObj (vla-AddBox modelSpace center boxLength boxWidth boxHeight)) ;; Change the viewing direction of the viewport to better see the box (setq NewDirection (vlax-3d-point -1 -1 1)) (setq activeViewport (vla-get-ActiveViewport doc)) (vla-put-Direction activeViewport NewDirection) (vla-put-ActiveViewport doc activeViewport) (vla-ZoomAll acadObj) ;; Return the ProductOfInertia for the box (setq ProductOfInertia (vlax-variant-value (vla-get-ProductOfInertia boxObj))) (alert (strcat "The ProductOfInertia for the box is " (rtos (vlax-safearray-get-element ProductOfInertia 0) 2) ", " (rtos (vlax-safearray-get-element ProductOfInertia 1) 2) ", " (rtos (vlax-safearray-get-element ProductOfInertia 2) 2))) ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2024-12-15 11:48
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.